<?php
//
//	file: install_sf/install.php
//	author: Dicky
//	author: ptirhiik
//	begin: 03/10/2006
//	version: 0.0.1 - 03/10/2006
//	version: 0.0.2 - 12/12/2006
//	license: http://opensource.org/licenses/gpl-license.php GNU General Public License (GPL)
//
function _sf_cat_id($cat_id)
{
	return POST_CAT_URL . '.' . intval($cat_id);
}

function _sf_forum_id($forum_id)
{
	return POST_FORUM_URL . '.' . intval($forum_id);
}

function _sf_reorder(&$res, &$tree, $id)
{
	// add the level
	$res[$id] = $tree[$id];

	// process the subs
	$count_subs = count($tree[$id]['subs']);
	for ( $i = 0; $i < $count_subs; $i++ )
	{
		_sf_reorder($res, $tree, $tree[$id]['subs'][$i]);
	}
}

define('IN_PHPBB', true);
define('IN_INSTALL', true);
$phpbb_root_path = '../';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);

//
// Start session management
//
$userdata = session_pagestart($user_ip, PAGE_INDEX);
init_userprefs($userdata);
//
// End session management
//

if ( !$userdata['session_logged_in'] )
{
	redirect(append_sid('login.' . $phpEx . '?redirect=install_sf/install.' . $phpEx, true));
}
if ( $userdata['user_level'] != ADMIN )
{
	redirect(append_sid('index.' . $phpEx, true));
	define('IN_ADMIN', true);
	message_die(GENERAL_MESSAGE, 'Not_Authorised');
}

// ok, now proceed
include($phpbb_root_path . 'includes/functions_sf.'.$phpEx);
_sf_lang($lang);
$error = false;

$template->assign_vars(array(
	'L_INSTALL' => $lang['sf_Install'],
	'CURRENT_VERSION' => SF_CURRENT_VERSION,
	'PREVIOUS_VERSION' => $board_config[SF_CONFIG_VERSION],
	'L_CURRENT_VERSION' => $lang['sf_current_version'],
	'L_PREVIOUS_VERSION' => $lang['sf_previous_version'],
));
$template->assign_block_vars('previous' . ($board_config[SF_CONFIG_VERSION] ? '' : '_ELSE'), array());

// does the field exists ?
$sql = 'SELECT forum_parent
			FROM ' . FORUMS_TABLE . '
			WHERE forum_id = 0';
$field_exists = ($result = $db->sql_query($sql, false, __LINE__, __FILE__, false));
$db->sql_freeresult($result);
if ( !$field_exists )
{
	$sqls = array();
	switch ( SQL_LAYER )
	{
		case 'mysql':
		case 'mysql4':
			$sqls = array(
				'ALTER TABLE ' . FORUMS_TABLE . '
					ADD COLUMN forum_parent mediumint(8) DEFAULT \'0\' NOT NULL',
			);
			break;

		case 'postgresql':
			$sqls = array(
				'ALTER TABLE ' . FORUMS_TABLE . '
					ADD COLUMN forum_parent int4',
				'UPDATE ' . FORUMS_TABLE . '
					SET forum_parent = 0
					WHERE forum_parent IS NULL',
				'ALTER TABLE ' . FORUMS_TABLE . '
					ALTER COLUMN forum_parent SET DEFAULT \'0\'',
			);
			break;

		case 'mssql-odbc':
		case 'mssql':
			$sqls = array(
				'ALTER TABLE ' . FORUMS_TABLE . '
					ADD forum_parent int NOT NULL,
					CONSTRAINT [DF_' . FORUMS_TABLE . '_forum_parent] DEFAULT (0) FOR [forum_parent]',
			);
			break;

		case 'msaccess':
			$sqls = array(
				'ALTER TABLE ' . FORUMS_TABLE . '
					ADD forum_parent int NOT NULL',
			);
			break;
	}

	$count_sqls = count($sqls);
	$template->assign_block_vars('sql' . ($count_sqls ? '' : '_ELSE'), array(
		'L_FAILED' => $lang['sf_SQL_failed'],
		'L_SUCCEED' => $lang['sf_SQL_succeed'],
	));
	$error = false;
	for ($i = 0; $i < $count_sqls; $i++ )
	{
		$sql = $sqls[$i];
		$failed = !$db->sql_query($sql, false, __LINE__, __FILE__, false);
		$template->assign_block_vars('sql.row', array(
			'L_SQL' => trim(preg_replace('/[\n\r\s\t]+/', ' ', $sql)),
		));
		$template->assign_block_vars('sql.row.success' . ($failed ? '_ELSE' : ''), array());
		if ( $failed )
		{
			$error = true;
		}
	}
}
if ( !$error )
{
	// get the tree and reorder
	$root = _sf_cat_id(0);
	$tree = array($root => array('subs' => array(), 'main' => '', 'id' => 0, 'type' => ''));

	$sql = 'SELECT cat_id
				FROM ' . CATEGORIES_TABLE . '
				ORDER BY cat_order';
	if ( !($result = $db->sql_query($sql)) )
	{
		define('IN_ADMIN', true);
		message_die(GENERAL_ERROR, 'Could not query the categories table', '', __LINE__, __FILE__, $sql);
	}
	while ( $row = $db->sql_fetchrow($result) )
	{
		$tree_id = _sf_cat_id($row['cat_id']);
		$tree[$tree_id] = array(
			'subs' => array(),
			'main' => $root,
			'id' => intval($row['cat_id']),
			'type' => POST_CAT_URL,
		);
		$tree[$root]['subs'][] = $tree_id;
	}
	$db->sql_freeresult($result);

	// read forums
	$sql = 'SELECT forum_id, cat_id, forum_parent, forum_order
				FROM ' . FORUMS_TABLE . '
				ORDER BY cat_id, forum_parent, forum_order';
	if ( !($result = $db->sql_query($sql)) )
	{
		define('IN_ADMIN', true);
		message_die(GENERAL_ERROR, 'Could not query the forums table', '', __LINE__, __FILE__, $sql);
	}
	while ( $row = $db->sql_fetchrow($result) )
	{
		$tree_id = _sf_forum_id($row['forum_id']);
		$parent_id = intval($row['forum_parent']) ? _sf_forum_id($row['forum_parent']) : _sf_cat_id($row['cat_id']);
		$tree[$tree_id] = array(
			'subs' => array(),
			'main' => $parent_id,
			'id' => intval($row['forum_id']),
			'type' => POST_FORUM_URL,
			'order' => intval($row['forum_order']),
		);
		if ( isset($tree[$parent_id]) )
		{
			$tree[$parent_id]['subs'][] = $tree_id;
		}
	}
	$db->sql_freeresult($result);

	$tree_ordered = array();
	_sf_reorder($tree_ordered, $tree, $root);
	$tree = $tree_ordered;
	unset($tree_ordered);

	// reorder the forums table
	$order = 0;
	$done = false;
	foreach ( $tree as $tree_id => $data )
	{
		if ( $data['type'] != POST_FORUM_URL )
		{
			$order = 0;
		}
		else
		{
			$order += 10;
			if ( $order != $data['order'] )
			{
				$done = true;
				$sql = 'UPDATE ' . FORUMS_TABLE . '
							SET forum_order = ' . intval($order) . '
							WHERE forum_id = ' . intval($data['id']);
				$db->sql_query($sql);
			}
		}
	}
	if ( $done )
	{
		$template->assign_vars(array(
			'L_ORDER' => $lang['sf_Forum_tree_ordered'],
		));
		$template->assign_block_vars('order', array());
	}
}

if ( !$error )
{
	$template->assign_vars(array(
		'L_END' => $lang['sf_Install_done'],
		'L_DELETE' => $lang['sf_Delete_install'],
		'L_BACK' => $lang['sf_Back_to_index'],
		'U_BACK' => append_sid($phpbb_root_path . 'index.' . $phpEx),
	));
	$template->assign_block_vars('install_end', array());
	if ( $board_config[SF_CONFIG_VERSION] )
	{
		$sql = 'UPDATE ' . CONFIG_TABLE . '
					SET config_value = \'' . SF_CURRENT_VERSION . '\'
					WHERE config_name = \'' . SF_CONFIG_VERSION . '\'';
		$db->sql_query($sql);
	}
	else
	{
		$sql = 'INSERT INTO ' . CONFIG_TABLE . '
					(config_name, config_value) VALUES(\'' . SF_CONFIG_VERSION . '\', \'' . SF_CURRENT_VERSION . '\')';
		$db->sql_query($sql);
	}
}

$page_title = $lang['sf_Install'];
$template->set_filenames(array('body' => '../../install_sf/install_body.tpl'));

define('IN_ADMIN', true);
include($phpbb_root_path . 'admin/page_header_admin.' . $phpEx);
$template->pparse('body');
include($phpbb_root_path . 'admin/page_footer_admin.' . $phpEx);

?>